# 認証後決済 実行

`PUT /v1/payments/{id}/secure`

- operationId: `executePaymentAfterThreeDSecureecure`
- tags: 決済

3Dセキュア認証後の決済を実行します。\
\
3Dセキュア認証APIもしくは認証結果確定APIのレスポンスの3Dセキュア認証結果（`tds2_trans_result`）が`Y`または`A`のとき、このAPIを実行して3Dセキュア認証後の決済を実行します。


## コードサンプル

### cURL

```bash
curl \
    -X PUT \
    -H "Authorization:Bearer <Secret API Key>" \
    -H "Content-Type: application/json" \
    -d '{
    "pay_type": "Card",
    "access_id": "<Access ID>"
}' \
'https://api.test.fincode.jp/v1/payments/{id}/secure'
```

### Node.js

```javascript
import { createFincode } from "@fincode/node";

const API_KEY = "<Secret API Key>";

(async () => {
    const fincode = createFincode({ apiKey: API_KEY, isLiveMode: false });

    const orderId = "<Order ID>";
    const accessId = "<Access ID>";

    try {
        // リクエストの送信
        const payment = await fincode.payments.executeAfter3DSecureAuth(
            orderId,
            {
                pay_type: "Card",
                access_id: accessId,
            }
        );
    } catch (e) {
        // エラーの処理
    }
})();
```

### Go

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"log"
	"net/http"
)

func main() {

	apiKey := "<Secret API Key>"

	orderID := "<Order ID>"

	body := ExecutingPaymentAfter3DSecureRequest{
		PayType:  "Card",
		AccessID: "<Access ID>",
	}

	marshalledBody, _ := json.Marshal(body)

	// リクエストの作成
	req, _ := http.NewRequest(
		"PUT",
		fmt.Sprintf("https://api.test.fincode.jp/v1/payments/%s/secure", orderID),
		bytes.NewBuffer(marshalledBody),
	)
	req.Header.Set("Authorization", fmt.Sprintf("Bearer %s", apiKey))
	req.Header.Set("Content-Type", "application/json")

	// リクエストの送信
	client := &http.Client{}
	res, err := client.Do(req)
	if err != nil {
		log.Fatal(err)
	}
	defer res.Body.Close()

}

type ExecutingPaymentAfter3DSecureRequest struct {
	PayType  string `json:"pay_type"`
	AccessID string `json:"access_id"`
}
```

### PHP

```php
<?php

$apiKey = '<Secret API Key>';

$orderId = '<Order ID>';

$baseUrl = "https://api.test.fincode.jp";
$endpoint = "/v1/payments/{$orderId}/secure";
$headers = [
    "Authorization: Bearer " . $apiKey,
    "Content-Type: application/json"
];

$data = json_encode([
    "pay_type" => "Card",
    "access_id" => "<Access ID>",
]);

$session = curl_init();
curl_setopt($session, CURLOPT_URL, $baseUrl . $endpoint);
curl_setopt($session, CURLOPT_HTTPHEADER, $headers);
curl_setopt($session, CURLOPT_CUSTOMREQUEST, 'PUT');
curl_setopt($session, CURLOPT_POSTFIELDS, $data);
curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
// curl_setopt($session, CURLOPT_SSL_VERIFYPEER, );
// curl_setopt($session, CURLOPT_SSL_VERIFYHOST, );

$response = curl_exec($session);

if ($response === false) {
    # エラー処理
    echo "cURL Error: " . curl_error($session);
} else {
    # APIからのデータを処理
    var_dump($response);
}

curl_close($session);
```

### Python 3

```python
import requests

api_key = '<Secret API Key>'

order_id = '<Order ID>'

url = f'https://api.test.fincode.jp/v1/payments/{order_id}/secure'

# ヘッダーを設定
headers = {
    'Authorization': f'Bearer {api_key}',
    'Content-Type': 'application/json'
}

data = {
    "pay_type": "Card",
    "access_id": "<Access ID>"
}

# HTTP POSTリクエストの送信
try:
    response = requests.put(url, headers=headers, json=data)

    # レスポンスの処理
    if response.status_code == 200:
        # 成功した場合の処理
        print(f"Success: {response.json()}")
    else:
        # エラーの処理
        print(f"Error: {response.json()}")
except requests.RequestException as e:
    # 通信エラーの処理
    print(f"Request error: {e}")
```

### Ruby

```ruby
require 'net/http'
require 'uri'
require 'json'


API_KEY = '<Secret API Key>'
BASE_URL = 'https://api.test.fincode.jp'

def main
    order_id = '<Order ID>'
    endpoint = "/v1/payments/#{order_id}/secure"
    
    uri = URI.parse(BASE_URL + endpoint)

    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true

    data = {
        pay_type: "Card",
        access_id: "<Access ID>",
    }

    # リクエストの作成
    request = Net::HTTP::Put.new(uri.request_uri)
    request['Authorization'] = "Bearer #{API_KEY}"
    request['Content-Type'] = 'application/json'

    request.body = data.to_json

    # リクエストの送信
    response = http.request(request)

    case response
    when Net::HTTPSuccess
        puts 'SUCCESS'
    else
        puts 'ERROR'
    end

    # レスポンスの表示
    puts response.body
end

main
```

## パラメータ

| 名前 | 位置 | 必須 | 型 | 説明 |
| --- | --- | --- | --- | --- |
| `Tenant-Shop-Id` | header |  | schema | <span class="smallText color--red-400">※ プラットフォームのメインショップのみ指定可</span> |
| `id` | path | ✓ | OrderId_schema | オーダーID（決済情報のID） |

## リクエストボディ

Content-Type: `application/json`

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `pay_type` | PayType | ✓ | 決済種別 |
| `access_id` | access_id | ✓ |  |
| `pa_res` | string |  | ※ 閉塞機能 |

## レスポンス

### 200 リクエストに成功

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `shop_id` | Shop_properties-id |  |  |
| `id` | string |  | オーダーID |
| `access_id` | string |  | 取引ID |
| `amount` | integer |  | 利用金額 |
| `tax` | integer |  | 税送料 |
| `total_amount` | integer(int64) |  | 合計金額 |
| `client_field_1` | client_field_n |  | 加盟店自由項目 1 |
| `client_field_2` | client_field_n |  | 加盟店自由項目 2 |
| `client_field_3` | client_field_n |  | 加盟店自由項目 3 |
| `process_date` | string |  | 決済 処理日時 |
| `customer_id` | id |  | 顧客ID |
| `customer_group_id` | string |  | 顧客情報共有グループID |
| `error_code` | error_code |  | この決済において発生したエラーのうち、一番最新のエラーのエラーコードです。 |
| `bill_id` | string |  | 請求ID |
| `created` | created |  |  |
| `updated` | updated |  |  |
| `pay_type` | PayType |  | 決済種別 |
| `job_code` | enum(CHECK | AUTH | CAPTURE | CANCEL) |  | 取引種別 |
| `status` | PaymentStatus |  | 決済ステータス |
| `card_id` | properties-id |  | カードID |
| `brand` | CardBrand |  |  |
| `card_no` | card_no |  |  |
| `expire` | expire |  |  |
| `holder_name` | holder_name |  |  |
| `card_no_hash` | card_no_hash |  |  |
| `method` | CardPayMethod |  |  |
| `pay_times` | CardPayTimesResponse |  |  |
| `bulk_payment_id` | PaymentBulk_properties-id |  | 一括決済ID |
| `subscription_id` | Subscription_properties-id |  | サブスクリプションID |
| `tds_type` | tds_type |  |  |
| `tds2_type` | tds2_type |  |  |
| `tds2_ret_url` | tds2_ret_url |  |  |
| `return_url` | x-req-properties-return_url |  |  |
| `return_url_on_failure` | x-req-properties-return_url_on_failure |  |  |
| `tds2_status` | ThreeDSecure2Status |  |  |
| `merchant_name` | td_tenant_name |  |  |
| `forward` | string |  | 仕向け先 |
| `issuer` | string |  | イシュア |
| `transaction_id` | string |  | トランザクションID |
| `approve` | string |  | 承認番号 |
| `auth_max_date` | string |  | 仮売上有効期限 |
| `item_code` | string |  | 商品コード |
| `send_url` | string |  | ※ 閉塞機能 |
| `acs` | string |  | ※ 閉塞機能 |

### 400 不正なリクエスト

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `errors` | array<FincodeAPIError> |  |  |

